/*->c.trans */

#include <stdafx.h>
#include "windows.h"
#include "shellapi.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>


#include "os.h"
#include "wimp.h"

#include "flex.h"
#include "alloc.h"
#include "etc.h"
#include "fsx.h"

#include "err.h"

#include "deb.h"

#include "oserr.h"

#include "trans.h"




static char * text;
static int    size;

static void stripcrlf(char * d,char * s,unsigned int * length)
{
 char * slt;
 char * d1;
 int    c;
 int    lc;

 slt=s+(*length);
 d1=d;
 c=32;
 while(s<slt)
 {
  lc=c;
  c=*s++;
  if(!(c<32 && lc<32)) *d++=(char)c;
 }
 *length=d-d1;
}



/* merge in a new translation table */

os_error * addtranstable2(char * path,char * leaf,int instance)
{
 os_error * err;
 char     * p;
 char     * q=NULL;
 char     * r1;
 char     * r2;
 unsigned int length=0;
 HANDLE     hDialog=NULL; 
 HRSRC      hRsrc;


// cprintf("addtrans %s",leaf);

 if(path)
 {

 }
 else
 {
  err=XFindResource((HINSTANCE)instance,leaf,"MESSAGES",&hRsrc);
  if(err)
  {
   err=NULL; // might be no messages
  }
  else
  {
   if(!err) err=XLoadResource((HINSTANCE)instance,hRsrc,(HGLOBAL*)&hDialog);
   if(!err) err=XLockResource(hDialog,(LPVOID*)&q);

   if(!err)
   {
             err=XSizeofResource((HINSTANCE)instance,hRsrc,&length);
    if(!err) err=srealloc((flex_ptr)&text,size+length+2);
    if(!err)  // strip CRLF pairs
    {
     stripcrlf(text+size,q,&length);
    }
   }
  }
 }



 if(!err)
 {
  p=text+size;

//  decryptresourceblock(p,&length); would be doomed if using \\ to mark eof

  *(p+length)=0;
  *(p+length+1)=0;

  r1=r2=q=p;

  while(1)
  {
   r1=p;
   while(*p && *p!=':') p++;
   *p++=0;
   if(!*p) break;
  
   r2=p;
   while(*p>=31) p++;
   *p++=0;
   if(!*p) break;
  }

  if((r2-r1)<2 || (p-r2)<2)
  {
   p=r1;
   *p=0;
  }

  size+=p-q;
 }

 return(err);
}



os_error * addtranstable(char * path,char * leaf)
{
 return(addtranstable2(path,leaf,(int)0));
}



char * transtoken(char * token)
{
 char * p;
 char * q;
 int    len;

// cprintf("transtoken %d %s",text,token);

 if(text)
 {
  p=text;

  while(1)
  {
   q=p;
   len=strlen(p);
   if(!len)
   {
    p=token;
    break;
   }
   p+=len+1;
//   cprintf("token %s %s",token,q);
   if(!strcmp(token,q)) break;
   len=strlen(p);
   if(!len)
   {
    p=token;
    break;
   }
   p+=len+1;
  }
 } else p=token;

 return(p);
}


#define MAXTOKSIZE 32



/* translate the text in the buffer */

os_error * trans(char * buffer,int maxlen)
{
 char * p;
 char * q;
 char * limit;
 char * ps;
 char   token[MAXTOKSIZE];
 int    size;
 int    len;
 int    delta;



 p=buffer;
 size=strlen(buffer);
 limit=token+MAXTOKSIZE-1;

 while(*p)
 {
  if(*p++=='{')
  {
   if(!*p) break;
   else
   if(*p=='{')
   {
    memmove(p-1,p,size-(p-buffer)+1);
    size--;
    p++;
   }
   else  /* a token */
   {
    q=token;
    ps=p;
    while(*p && *p!='}' && q<limit) *q++=*p++;
    if(!*p || q>=limit)
    {
     p=ps;
    }
    else
    {
     *q=0;
     p++;
     q=transtoken(token);
     
     len=strlen(q);
     delta=len-(2+strlen(token));

     if((size+delta)<maxlen)
     {
      memmove(p+delta,p,size-(p-buffer)+1);
      p+=delta-len;
      size+=delta;
      XMEMCPYX(p,q,len);
     }
    }
   }
  }
 }

 return(NULL);
}


os_error * tsprintf(int maxlen,char * string,char * format, ...)
{
 os_error * err;
 va_list    args;
 char       buffer[256];

 va_start(args,format);
 strcpy(buffer,format);
 err=trans(buffer,sizeof(buffer));
 vsprintf(string,buffer,args);
 va_end(args);
 if(!err) err=trans(string,maxlen);

 return(err);
}


os_error * inittrans(void)
{
 os_error * err;

 err=salloc((flex_ptr)&text,0);
 size=0;

 return(err);
}



